r"""Run inference on an image or group of images."""
from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

import os
import timeit
import numpy as np
from PIL import Image
import tensorflow as tf
from google.protobuf import text_format
import argparse
import pdb
import scipy.misc
from tensorflow.python.platform import gfile
from tensorflow.python.framework import graph_util

os.environ['CUDA_VISIBLE_DEVICES'] = '-1'

slim = tf.contrib.slim


def conv_map(x, size, shape, stride, padding='VALID'):
    w = tf.get_variable("filter",
                        shape=[shape, shape, x.get_shape()[3], size],
                        initializer=tf.contrib.layers.xavier_initializer())
    b = tf.Variable(tf.zeros(size), name='biases')
    x = tf.nn.conv2d(x, w, strides=[1, stride, stride, 1], padding=padding)
    x = tf.nn.bias_add(x, b)
    x = tf.nn.relu(x)
    return x
    
    
def run_inference_graph():
    #saver = tf.train.Saver(max_to_keep=20)
    with tf.Session() as sess:
        placeholder_tensor =  tf.placeholder(dtype=tf.float32, shape=(1, 361, 641, 3))
        paddings = tf.constant([[0, 0], [3, 3],
                                  [3, 3], [0, 0]])
        x = tf.pad(placeholder_tensor, paddings, "CONSTANT")
        image_tensor_tensor = conv_map(x,  32, 7, 2)
        # Initialization
        init = tf.global_variables_initializer()
        sess.run(init)
        #feed input
        image_raw=np.random.rand(1,361,641,3)
        image_tensor_tensor_ = sess.run(image_tensor_tensor, feed_dict={placeholder_tensor: image_raw})
        pdb.set_trace()
        ## dump the graph for serialization
        graph = tf.get_default_graph()
        input_graph_def = graph.as_graph_def()
        output_graph_def = graph_util.convert_variables_to_constants(
            sess, input_graph_def, ['Relu'])

        with open("myexp.pb", "wb") as f:
            f.write(output_graph_def.SerializeToString())

def main(_):
    run_inference_graph()

if __name__ == '__main__':
    tf.app.run()
